"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function sequentialise(object) {
    return atInitialStep(object);
}
exports.sequentialise = sequentialise;
function atInitialStep(object) {
    return {
        configure: function (args) {
            object.configure(args);
            return atConfigurationStep(object);
        },
        given: function (args) {
            return atGivenStep(object, object.given(args));
        }
    };
}
function atConfigurationStep(object) {
    return {
        and: function (args) {
            object.configure(args);
            return atConfigurationStep(object);
        },
        given: function (args) {
            return atGivenStep(object, object.given(args));
        }
    };
}
function atGivenStep(object, promise) {
    return {
        and: function (args) {
            return atGivenStep(object, promise.then(function () { return object.given(args); }));
        },
        when: function (args) {
            return atWhenStep(object, promise.then(function () { return object.when(args); }));
        }
    };
}
function atWhenStep(object, promise) {
    return {
        and: function (args) {
            return atWhenStep(object, promise.then(function () { return object.when(args); }));
        },
        then: function (args) {
            return atThenStep(object, promise.then(function () { return object.then(args); }));
        }
    };
}
function atThenStep(object, promise) {
    return {
        and: function (args) {
            return atThenStep(object, promise.then(function () { return object.then(args); }));
        },
        finally: function (done) {
            promise.then(done);
        }
    };
}
