import { Store, Middleware } from "redux";
export declare type PageModel = Object;
export declare type Enhancer<Dispatch, State, Application extends PageModel> = (dispatch: Dispatch, state: State) => Application;
interface GetTesterArguments<State, EntryPoints, Dispatch, Application extends PageModel> {
    getStore: (...additionalMiddlewares: Middleware[]) => Store<State> & {
        dispatch: Dispatch;
    };
    entryPoints: EntryPoints;
    enhancer: Enhancer<Dispatch, State, Application>;
}
declare type Logger = (s: string) => void;
export interface ConfigurationHandlers {
    debug: {
        logActions(logger?: Logger): void;
        logState(logger?: Logger): void;
    };
}
export interface GivenHandlers<EntryPoints, Application> {
    enter: (sequence: keyof EntryPoints) => void;
    application: Application;
}
export interface WhenHandlers<Application> {
    application: Application;
}
export interface ThenHandlers<Application> {
    application: Application;
    actions: any[];
}
export declare const noop: () => void;
export declare function getTester<State, EntryPoints, Dispatch, Application extends PageModel>(args: GetTesterArguments<State, EntryPoints, Dispatch, Application>): import("./sequentialiser").TesterAtInitialStep<(helpers: ConfigurationHandlers) => void, (helpers: GivenHandlers<EntryPoints, Application>) => void | Promise<void>, (helpers: WhenHandlers<Application>) => void | Promise<void>, (helpers: ThenHandlers<Application>) => void | Promise<void>>;
export {};
