"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var lodash_1 = require("lodash");
var sequentialiser_1 = require("./sequentialiser");
exports.noop = function () {
    return;
};
var defaultActionLogger = function (s) { return console.log(chalk_1.default.black.bgWhite.bold(" ACTION "), "\n", s); };
var defaultStateLogger = function (s) { return console.log(chalk_1.default.black.bgWhite.bold(" STATE "), "\n", s); };
var Tester = /** @class */ (function () {
    function Tester(_a) {
        var _this = this;
        var getStore = _a.getStore, entryPoints = _a.entryPoints, enhancer = _a.enhancer;
        this.step = "CONFIGURE";
        this.actions = [];
        this.actionLogger = exports.noop;
        this.stateLogger = exports.noop;
        this.logActionsMiddleware = function (_) { return function (next) { return function (action) {
            if (_this.step === "WHEN") {
                _this.actions.push(action);
                _this.actionLogger(action.toString());
            }
            return next(action);
        }; }; };
        this.logState = function () {
            _this.store.subscribe(function () {
                if (_this.step === "WHEN") {
                    _this.stateLogger(JSON.stringify(_this.store.getState()).toString());
                }
            });
        };
        this.playSequence = function (sequence) {
            _this.entryPoints[sequence].forEach(function (action) {
                _this.store.dispatch(action);
            });
        };
        this.configure = function (callback) {
            var helpers = {
                debug: {
                    logActions: function (logger) {
                        if (logger === void 0) { logger = defaultActionLogger; }
                        _this.actionLogger = logger;
                    },
                    logState: function (logger) {
                        if (logger === void 0) { logger = defaultStateLogger; }
                        _this.stateLogger = logger;
                    }
                }
            };
            callback(helpers);
        };
        this.given = function (callback) { return __awaiter(_this, void 0, void 0, function () {
            var helpers;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.step = "GIVEN";
                        helpers = {
                            enter: this.playSequence,
                            application: this.enhancer(this.store.dispatch, {})
                        };
                        return [4 /*yield*/, callback(helpers)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.when = function (callback) { return __awaiter(_this, void 0, void 0, function () {
            var helpers;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.step = "WHEN";
                        helpers = {
                            application: this.enhancer(this.store.dispatch, {})
                        };
                        return [4 /*yield*/, callback(helpers)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.then = function (callback) {
            _this.step = "THEN";
            var helpers = {
                application: _this.enhancer(_this.store.dispatch, lodash_1.cloneDeep(_this.store.getState())),
                actions: _this.actions
            };
            callback(helpers);
        };
        this.store = getStore(this.logActionsMiddleware);
        this.enhancer = enhancer;
        this.entryPoints = entryPoints;
        this.logState();
    }
    return Tester;
}());
function getTester(args) {
    return sequentialiser_1.sequentialise(new Tester(args));
}
exports.getTester = getTester;
